# -*- coding: utf-8 -*-
# Algorithmus-von-Kruskal.py
# basiert auf Algorithmus-von-Kruskal-2020.py

from gallenbacher_kanten import *

## Kanten: [<knoten-1>, <knoten-2>, <bewertung>]

### ===== Funktionen zum Sortieren
# ----- kuerzer -----
def kuerzer(kante1, kante2):
    return  (kante1[2] < kante2[2])

# ----- ordneKanten -----
def ordneKanten(kanten):
    sortierte=[]
    for kante in kanten:
        sortierte=ordneEin(kante, sortierte)
    return sortierte

# ----- ordneEin -----
# sortiert durch Einfuegen
def ordneEin(kante, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(kante, sortierte[index]):
            sortierte[index:index]=[kante]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[kante]
    return sortierte

### ===== Teilbaeume initialisieren =====
# ----- erzeugeTeilbaeume -----
# erzeugt den Anfangszustand aus der Kantenliste
def erzeugeTeilbaeume(kanten):
    alleKnoten=gibAlleKnoten(kanten)
    teilbaeume=[]
    for knoten in alleKnoten:
        teilbaeume.append([[knoten],[]])
    return teilbaeume

def gibAlleKnoten(kanten):
    alleKnoten=[]
    for kante in kanten:
        if not(kante[0] in alleKnoten):
            alleKnoten.append(kante[0])
        if not(kante[1] in alleKnoten):
            alleKnoten.append(kante[1])
    return alleKnoten

### ===== Funktionen fuer die Schritte =====        
# ----- knotenImTeilbaum -----
# prueft, ob ein knoten in einem teilbaum enthalten ist
def knotenImTeilbaum(knoten, teilbaum):
    return teilbaum[0].count(knoten)==1

# ----- posTeilbaumZuKnoten -----
# gibt zu einem Knoten die Position des Teilbaums in der
# Teilbaumliste zurueck, die den Knoten enthaelt
def posTeilbaumZuKnoten(knoten, teilbaeume):
    for teilbaum in teilbaeume:
        if knotenImTeilbaum(knoten, teilbaum):
            return teilbaeume.index(teilbaum)
  
# ----- verbinde -----
# verbindet die beiden Teilbaeume durch die Kante.
def verbinde(kante, erster, zweiter, alleTeilbaeume):
    tb1,tb2=alleTeilbaeume[erster],alleTeilbaeume[zweiter]
    neu=[ tb1[0]+tb2[0], [kante]+tb1[1]+tb2[1] ]    
    alleTeilbaeume.remove(tb1)
    alleTeilbaeume.remove(tb2)
    alleTeilbaeume.append(neu)
    return alleTeilbaeume

# ----- kruskal -----
# die Suchfunktion
def kruskal(kanten):
    kanten=ordneKanten(kanten)
    teilbaeume=erzeugeTeilbaeume(kanten)
    for kante in kanten:
        ##input(teilbaeume)
        erster=posTeilbaumZuKnoten(kante[0], teilbaeume)
        zweiter=posTeilbaumZuKnoten(kante[1], teilbaeume)        
        if erster!=zweiter:
            tbaeume=verbinde(kante, erster, zweiter, teilbaeume)
            if len(teilbaeume)==1:
                return teilbaeume[0][1]
    return "Fehler"


### ===== Testaufrufe =====
##print( kruskal(mustergraph+umkehrung) )
print( kruskal(kanten) )

